"""A test program which reads an ARFF file into a table, and then
writes it back.  Between reading and writing transofrmations can
be applied."""

import sys
import types

sys.path.append("..")

from DataAccess import Attr, AttrSet, create_arff_reader, make_arff_header


if __name__ == "__main__":
    infile = "iris.arff"
    infile = "/tmp/in.arff"
    infile = "/home/szymon/dmining/data/DrCiechanowicz/dSS/dSS.arff"
    outfile = "/tmp/out.arff"
    #outfile = sys.stdout

    # read an arff file into memory
    ar = create_arff_reader(infile)
    data = list(ar)

    # discretize dSS, delete MAP < 100
    ar.attrset[6].type = "CATEG"
    ar.attrset[6].domain = ["low","hi"]
    data2 = []
    for i, row in enumerate(data):
        MAP = row[5]
        if MAP < 100:
            continue
        dSS = row[6]
        if dSS is not None:
            if dSS <= 12:
                dSS = 0
            else:
                dSS = 1
        row[6] = dSS
        data2.append(row)
    data = data2

    # write data to disk
    if isinstance(outfile, types.StringTypes):
        outfile = file(outfile, "wU")
    header = make_arff_header(ar.attrset)
    print >>outfile, header
    for row in data:
        print >>outfile, ar.str_record(row)
    
